package org.sitebricks.decorator.freemarker;

import java.util.HashMap;
import java.util.Map;

import org.sitebricks.extractor.ExtractResult;
import org.sitebricks.extractor.XhtmlExtractor;
import org.sitebricks.extractor.jsoup.JSoupXhtmlExtractor;

public class XhtmlPageSource implements ContextSource {

  private String xhtml;
  
  public XhtmlPageSource(String xhtml) {
    this.xhtml = xhtml;
  }

  public Map<String, Object> source() {
    Map<String, Object> context = new HashMap<String,Object>();
    XhtmlExtractor extractor = new JSoupXhtmlExtractor();
    //
    // Extract content from page
    //
    if (xhtml != null) {
      ExtractResult er = extractor.extract(xhtml);
      context.put("title", er.getTitle());
      context.put("body", er.getBody());
      context.put("head", er.getHead());
      context.put("links", er.getLinks());
      StringBuffer javascriptElements = new StringBuffer();
      for(String javascriptElement : er.getJavascriptReferences()) {
        javascriptElements.append(javascriptElement);
      }
      context.put("javascript", javascriptElements.toString());
    }    
    return context;
  }
}
